body  {
	color:<?php echo $bodyText; ?>;
    background:<?php echo $backgroundColor; ?>;
}

.topline, .discount_text {
	background:<?php echo $topLineColor; ?>;
}

#wrapper {
	width:<?php echo $overallWidth; ?>px;
}

#topmenu,#topmenu_nav,.path,.upper,.bottom,.main_area,.footer_content,.footer_wrap_copyright_content {
	width:<?php echo $templateWidth; ?>px;
}

<?php
	$topmenuwidth = $templateWidth - 290;
?>

#topmenu_pad {
	width: <?php echo $topmenuwidth; ?>px;
}

#nav {
	width: <?php echo $topmenuwidth; ?>px;
}

.content_wrap {
	width:<?php echo $contentWidth; ?>px;
}

.column_left {
	width:<?php echo $columnLeftWidth; ?>px;
}

.column_right {
	width:<?php echo $columnRightWidth; ?>px;
}

.upper .module_padding {
	width:<?php echo $advert_width; ?>px;
}

.bottom .module_padding {
	width:<?php echo $bottom_width; ?>px;
}

.footer_content .module_padding {
	width:<?php echo $footer_width; ?>px;
}

.componentheading, h1 {
	color:<?php echo $componentHeadingText; ?>;
}

.contentheading, h2, h3, h4, .contentheading a.contentpagetitle, #form1 label, .search label {
	color:<?php echo $headingText; ?>;
}

a.contentpagetitle:hover h2 {
	color:<?php echo $headingHoverText; ?>;
}

.column_right div.moduletable, .column_left div.moduletable, .column_right ul.menu li span.separator, .column_left ul.menu li span.separator, #form-login li a  {
    color:<?php echo $columnText; ?>;
}

.column_right ul.menu li span.separator, .column_left ul.menu li span.separator, #form-login li {
	border-bottom:1px dotted <?php echo $inputShadow; ?>;
}

div.moduletable h3 span {
	color:<?php echo $columnFirstWord; ?>;
}

div.moduletable h3 {
	color:<?php echo $columnHeading; ?>;
    background:<?php echo $columnHeadingBg; ?>;
}

div.moduletable_featured h3, div.moduletable_featured, div.moduletable_featured p, .promo_small, .promo_medium {
	color:<?php echo $featuredText; ?>;
}

.module_inset, div.moduletable_featured {
	background-color:<?php echo $featuredBg; ?>;
}

.column_right ul.menu li a:link, .column_right ul.menu li a:visited, .column_left ul.menu li a:link, .column_left ul.menu li a:visited {
	color:<?php echo $columnLink; ?>;
}

#topmenu ul.menu > li:hover, #topmenu ul.menu > li.current {
	background:<?php echo $topMenuActiveBg; ?>;
	color:<?php echo $topMenuHoverText; ?>;
}

#topmenu ul.menu > li:hover > a, #topmenu ul.menu > li.current a:hover {
	color:<?php echo $topMenuHoverText; ?> !important;
}

#topmenu ul.menu li:hover a:link, #topmenu ul.menu li:hover a:visited {
	color:<?php echo $topMenuSubText; ?>;
}

#nav a {
	color:<?php echo $topMenuText; ?>;
}

#nav li:hover a {
    color:<?php echo $topMenuHoverText; ?>;
}

#nav li:hover ul li a {
	color:<?php echo $topMenuSubText; ?>;
}

#nav li:hover ul li a:hover {
	background:<?php echo $topMenuSubBgHover; ?>;
	color:<?php echo $topMenuSubTextHover; ?>;
}

#nav > li {
	border-right:1px dotted <?php echo $inputShadow; ?>;
	border-left:1px dotted <?php echo $inputShadow; ?>;
}

a:link,a:visited,.plan_hightlights {
	color:<?php echo $linksColor; ?>;
}

.column_right li.active a:link,.column_right li.active a:visited,.column_left li.active a:link,.column_left li.active a:visited {
	color:<?php echo $linksColor; ?> !important;
}

#carousel_wrap, #path_wrap {
	background:url(<?php echo $template_path; ?>/images/bg_gradient.png) repeat-x;
}

.footer_wrap, .footer_wrap_copyright {
	background-color:<?php echo $footerWrapBg; ?>;
}

.footer_content div.moduletable, .footer_wrap_copyright, .footer_content div.moduletable h3, .footer_content div.moduletable h3 span {
	color:<?php echo $footerText; ?>;
}

.footer_wrap div.moduletable h3 {
	border-bottom:1px solid <?php echo $footerText; ?>;
}

.footer_content a:link,.footer_content a:visited,.footer_wrap_copyright a:link,.footer_wrap_copyright a:visited {
    color:<?php echo $footerLink; ?>;
    font-weight:normal;
}

.footer_content a:hover {
	color:<?php echo $footerLinkHover; ?>;
}

#form1 #register, .button, button {
	background:<?php echo $buttonsBg; ?>;
    color:<?php echo $buttonsText; ?>;
}

.inputbox, input, #form1 #domain, #form1 #tld {
	background:<?php echo $backgroundColor; ?>;
    color:<?php echo $bodyText; ?>;
}

#form1 #domain, #form1 #tld, .inputbox, input {
	border-right:1px solid <?php echo $inputShadow; ?>;
	border-bottom:1px solid <?php echo $inputShadow; ?>;
}

#topmenu_nav_wrap {
	border-top:1px solid <?php echo $inputShadow; ?>;
}

.cloud_table td {
	border-bottom:1px solid <?php echo $inputShadow; ?>;
}
